apps/configuration/urls.py
from django.urls import path

from .views import EditionNotesView

app_name = "configuration"

urlpatterns = [
    # The 'home' route points to the list
    path("", EditionNotesView.as_view(), name="release_notes"),
]

apps/questionnaire/urls.py
from django.urls import include, path

from . import views

urlpatterns = [
    path("upload/", views.generic_file_upload, name="file_upload"),
    path("file/<action>/<uid>/", views.generic_file_serve, name="file_serve"),
    path(
        "edit/<identifier>/lock/",
        views.QuestionnaireLockView.as_view(),
        name="lock_questionnaire",
    ),
    path("geo/", views.get_places, name="slm_places"),
    path("update/", views.get_places, name="update_slm_places"),
    path("", include("apps.sample.urls")),
]

apps/wocat/urls.py
from django.urls import path
from django.views.generic import TemplateView

from apps.questionnaire.views import QuestionnaireListView, QuestionnaireFilterView

app_name = "wocat"

urlpatterns = [
    path("", TemplateView.as_view(template_name="wocat/home.html"), name="home"),
    path(
        "help/questionnaire/",
        TemplateView.as_view(
            template_name="wocat/help/questionnaire_introduction.html"
        ),
        name="help_questionnaire_introduction",
    ),
    path("faq/", TemplateView.as_view(template_name="wocat/faq.html"), name="faq"),
    path("add/", TemplateView.as_view(template_name="wocat/add.html"), name="add"),
    path(
        "list/",
        QuestionnaireListView.as_view(configuration_code=__package__),
        name="questionnaire_list",
    ),
    path(
        "list_partial/",
        QuestionnaireListView.as_view(configuration_code=__package__),
        name="questionnaire_list_partial",
    ),
    path(
        "filter/",
        QuestionnaireFilterView.as_view(configuration_code=__package__),
        name="questionnaire_filter",
    ),
    path(
        "filter_partial/",
        QuestionnaireFilterView.as_view(configuration_code=__package__),
        name="questionnaire_filter_partial",
    ),
    # path("", include(("apps.accounts.urls", "accounts"), namespace="accounts")),
    # path("", include(("apps.approaches.urls", "approaches"), namespace="approaches")),
    # path("", include(("apps.sample.urls", "sample"), namespace="sample")),
    # path("", include(("apps.api.urls.v1", "v1"), namespace="v1")),
    # path(
    #     "", include(("apps.samplemulti.urls", "samplemulti"), namespace="samplemulti")
    # ),
    # path(
    #     "",
    #     include(("apps.samplemodule.urls", "samplemodule"), namespace="samplemodule"),
    # ),
]

config/urls.py
from django.conf import settings
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import reverse_lazy, path, include
from django.views.generic import TemplateView, RedirectView

from apps.qcat.views import AdminLoginView, FactsTeaserView

urlpatterns = [
    path("about/", include("apps.qcat.urls")),
    path("grappelli/", include("grappelli.urls")),
    path("admin/login/", AdminLoginView.as_view(), name="admin_login"),
    path("admin/", admin.site.urls),
    # path("sitemap.xml", sitemap, {"sitemaps": views.static_sitemap}, name="django.contrib.sitemaps.views.sitemap",),
    path("robots.txt", TemplateView.as_view(template_name="robots.txt")),
    path("api/temp1/", include("apps.api.urls.temp")),
]
# en/questionnaire
urlpatterns += i18n_patterns(
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("wocat:home"), permanent=False),
        name="home",
    ),
    path("accounts/", include("apps.accounts.urls")),
    path("api/", include("apps.api.urls")),
    path("configuration/", include("apps.configuration.urls")),
    path("notifications/", include("apps.notifications.urls")),
    path("qcat/facts_teaser", FactsTeaserView.as_view(), name="facts_teaser"),
    path("questionnaire/", include("apps.questionnaire.urls")),
    path("search/", include("apps.search.urls")),
    path("samplemulti/", include("apps.samplemulti.urls")),
    path("summary/", include("apps.summary.urls")),
    path("unccd/", include("apps.unccd.urls")),
    path("wocat/", include("apps.wocat.urls")),
    path("wocat/approaches/", include("apps.approaches.urls")),
    path("wocat/cca/", include("apps.cca.urls")),
    path("wocat/cbp/", include("apps.cbp.urls")),
    path("wocat/technologies/", include("apps.technologies.urls")),
    path("wocat/watershed/", include("apps.watershed.urls")),
)

if settings.DEBUG:
    urlpatterns += [path("__debug__/", include("debug_toolbar.urls"))]

urlpatterns += i18n_patterns(
    path("samplemodule/", include("apps.samplemodule.urls")),
    path("404/", TemplateView.as_view(template_name="404.html")),
    path("500/", TemplateView.as_view(template_name="500.html")),
    path("503/", TemplateView.as_view(template_name="503.html")),
) + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

apps/questionnaire/api/views.py
import logging
from collections import OrderedDict

from PIL import Image
from django.core.paginator import EmptyPage
from django.db.models import Q
from django.http import Http404
from django.shortcuts import get_list_or_404
from django.utils import timezone
from django.utils.translation import get_language
from rest_framework import status
from rest_framework.generics import GenericAPIView, get_object_or_404
from rest_framework.mixins import CreateModelMixin
from rest_framework.parsers import FormParser, MultiPartParser
from rest_framework.response import Response
from rest_framework.reverse import reverse
from rest_framework.throttling import UserRateThrottle
from rest_framework.utils.urls import remove_query_param, replace_query_param
from rest_framework.views import APIView

from apps.api.views import LogEditAPIMixin, AppPermissionMixin
from apps.api.views import LogUserMixin, PermissionMixin
from apps.configuration.cache import get_configuration
from apps.configuration.configured_questionnaire import ConfiguredQuestionnaire
from apps.configuration.structure import ConfigurationStructure
from apps.questionnaire.serializers import QuestionnaireInputSerializer
from apps.questionnaire.utils import (
    validate_questionnaire_data,
    compare_questionnaire_data,
)
from apps.questionnaire.views import ESQuestionnaireQueryMixin
from apps.search.search import get_element
from ..conf import settings
from ..models import Questionnaire, APIEditRequests, File
from ..utils import get_list_values, get_questionnaire_data_in_single_language

logger = logging.getLogger(__name__)


class QuestionnaireAPIMixin(PermissionMixin, LogUserMixin, GenericAPIView):
    """
    Shared functionality for list and detail view.
    """

    add_detail_url = False

    def update_dict_keys(self, es_hits: list):
        """
        Some keys need to be updated (e.g. description has a different key
        depending on the config) for a more consistent behavior of the APIs
        data.
        This cannot be done when indexing (opensearchpy) the data, as the
        templates expect the variable names in the 'original' format.
        After discussion with the people consuming the api, the language of
        the content is used as key, i.e.: 'unccd_description': 'a title' becomes
        'definition: {'en': 'a title'}
        """
        for es_hit in es_hits:
            yield self.replace_keys(es_hit)

    def language_text_mapping(self, **item) -> list:
        """
        The consumers of the API require the text values in the format:
        {
            'language': 'en',
            'text': 'my text'
        }
        """
        return [{"language": key, "text": value} for key, value in item.items()]

    def replace_keys(self, es_hit: dict) -> dict:
        """
        Replace all keys as defined by the configuration. Also, list all
        translated versions. This was requested by the consumers of the API.
        To access description and name in all versions, the config must be
        loaded again.
        """
        try:
            list_values = get_list_values(es_hits=[es_hit])[0]
        except IndexError:
            # We want to know about these errors.
            raise Exception(
                "Possibly invalid data in ES (unable to serialize)" ": %s" % es_hit
            )

        # 'name' and 'definition' must include all translations.
        list_values["name"] = es_hit["_source"]["list_data"]["name"]
        list_values["definition"] = es_hit["_source"]["list_data"]["definition"]

        # Restore state of configuration for v1.
        list_values["configurations"] = [list_values["configuration"]]
        list_values["native_configuration"] = True

        # Remove keys that are not available on v1.
        delete_keys = [
            "serializer_config",
            "serializer_edition",
            "has_new_configuration_edition",
        ]
        for key in delete_keys:
            del list_values[key]

        # Add 'full' data, even for the list view.
        list_values["data"] = self.get_object_data(code=list_values["code"])

        if self.add_detail_url:
            list_values["api_url"] = reverse(
                "{api_version}:questionnaires-api-detail".format(
                    api_version=self.request.version
                ),
                kwargs={"identifier": list_values["code"]},
            )

        return list_values

    def get_object_data(self, code: str) -> dict:
        obj = (
            self.object
            if hasattr(self, "object")
            else self.get_current_object(code=code)
        )
        return obj.data

    def _filter_dict(self, items: list[dict]):
        """
        Starting with API v2 only name and url to the detail page are displayed.
        """
        for item in items:
            yield {
                "name": item.get("name"),
                "compilers": item.get("compilers"),
                "reviewers": item.get("reviewers"),
                "created": item.get("created"),
                "updated": item.get("updated"),
                "labels": [x.slug for x in item.get("labels", []) or []],
                "coordinates": item.get("geom"),
                "code": item.get("code"),
                "edition": item.get("serializer_edition"),
                "url": reverse(
                    viewname="{configuration}:questionnaire_details".format(
                        configuration=item["configuration"]
                    ),
                    kwargs={"identifier": item["code"]},
                ),
                "translations": item.get("translations"),
                "details": reverse(
                    "{api_version}:questionnaires-api-detail".format(
                        api_version=self.request.version or "api:v2"
                    ),
                    kwargs={"identifier": item["code"]},
                ),
            }

    def get_current_object(self, code="") -> Questionnaire:
        """
        Check if the model entry is still valid.

        Returns: object (Questionnaire instance)
        """
        return get_object_or_404(
            Questionnaire.with_status.public(), code=self.kwargs.get("identifier", code)
        )


class QuestionnaireListView(QuestionnaireAPIMixin, ESQuestionnaireQueryMixin):
    """
    Get a list of Questionnaires, for v1 and v2

    Return a list of Questionnaires. The same filter parameters as for the list
    view (search/filter in QCAT) can be passed.

    ``page``: Optional page offset.
    """

    page_size = settings.API_PAGE_SIZE
    add_detail_url = True
    configuration_code = "wocat"

    def get(self, request, *args, **kwargs) -> Response:
        self.set_attributes()
        items = self.get_elasticsearch_items()
        return self.get_paginated_response(items)

    def get_elasticsearch_items(self):
        """
        Don't touch the database, but fetch everything from opensearchpy.

        Returns:
            list of questionnaires
        """
        es_results = self.get_es_results(call_from="api")

        es_pagination = self.get_es_paginated_results(es_results)
        questionnaires, self.pagination = self.get_es_pagination(es_pagination)

        # Combine configuration and questionnaire values.
        if self.request.version == "v1":
            return self.update_dict_keys(es_hits=questionnaires)
        else:
            return self._filter_dict(get_list_values(es_hits=questionnaires))

    def get_paginated_response(self, data) -> Response:
        """
        Build a response as if it were from the django rest framework. This
        will be replaced after the refactor.

        Args:
            data: dict The data which is returned

        Returns:
            Response

        """
        return Response(
            OrderedDict(
                [
                    ("count", self.pagination.count),
                    ("next", self.get_next_link()),
                    ("previous", self.get_previous_link()),
                    ("results", list(data)),
                ]
            )
        )

    def _get_paginate_link(self, page_number) -> str:
        """
        Args:
            page_number: int

        Returns:
            string: URL of the requested page

        """
        try:
            self.pagination.validate_number(page_number)
        except EmptyPage:
            return ""

        url = self.request.build_absolute_uri()
        if page_number == 1:
            return remove_query_param(url, "page")
        return replace_query_param(url, "page", page_number)

    def get_next_link(self) -> str:
        return self._get_paginate_link(self.current_page + 1)

    def get_previous_link(self) -> str:
        return self._get_paginate_link(self.current_page - 1)


class QuestionnaireDetailView(QuestionnaireAPIMixin):
    """
    Return a single item from opensearchpy, if object is still valid on the
    model.

    Used for API v1 only
    """

    add_detail_url = False

    def get(self, request, *args, **kwargs):
        """
        Set the current object to 'self', so the query is not executed again
        in the method 'replace_keys'.
        """
        self.object = self.get_current_object()
        # Get the single element from ES.
        es_hit = get_element(questionnaire=self.object)
        if not es_hit:
            raise Http404

        return Response(self.replace_keys(es_hit={"_source": es_hit}))


class ConfiguredQuestionnaireDetailView(QuestionnaireDetailView):
    """
    Get a single Questionnaire for API v2.

    Return a single Questionnaire by its code. The returned data contains the
    full configuration (including labels of sections, questiongroups etc.).

    ``identifier``: The identifier / code of the questionnaire.
    """

    def prepare_data(self) -> dict:
        """
        Merge configuration keyword, label and questionnaire data to a dict.
        """

apps/questionnaire/templates/details/media_gallery.html
{% load i18n %}

<div class="row is-rhythmed">
  <div class="small-12 columns gallery">
    <h2 class="is-unvisible">{% trans "Media Gallery" %}</h2>
    <ul class="small-block-grid-3 medium-block-grid-6 clearing-thumbs" data-clearing="">
      {% for data in media_content %}
        {% if data.image %}
          <li>
            <a class="th th-item" href="{{ data.image }}" style="background-image: url('{{ data.interchange_list.1.0 }}')">
              <img class="transparent"
                   src="{{ data.interchange_list.1.0 }}"
                   data-caption="{{ data.caption }}<br><i>{{ data.location|default:'' }}</i><br><i>{{ data.date|default:'' }}</i><br><strong>Photo: {{ data.photographer|default:'-' }}</strong>">
            </a>
          </li>
        {% endif %}
      {% endfor %}
    </ul>
  </div>
  {% if media_additional %}
    <div class="small-12 columns output">
      {% if media_additional.image_remarks %}
        <h5>{{ media_additional.label_image_remarks }}{% if media_additional.label_image_remarks|last not in ".:!?" %}: {% endif %}</h5>
        <p>{{ media_additional.image_remarks }}</p>
      {% endif %}
    </div>
  {% endif %}
</div>

apps/questionnaire/templates/details/modal_map.html
{% extends 'form/base.html' %}

{% load i18n static %}

{% block bodyclass %}layout-map-modal{% endblock %}

{% block content %}
  <div class="list-item" id="map-details-overlay">
    <div class="map-container">
      <div class="map-controls">
        <div class="map-controls-group">
          <button type="button" class="map-controls-button button small tip-right button-feature-count js-btn-feature-count" title="{% trans "Number of points on the map" %}" data-tooltip="">
          </button>
          <button type="button" class="map-controls-button button small tip-right map-btn-disabled map-btn-toggle js-btn-show-features" title="{% trans "Zoom to all points on the map" %}" data-tooltip="">
            <svg class="icon-lines is-inline"><use xlink:href="#icon-shrink"></use></svg>
          </button>
        </div>
      </div>
      <div class="map-overlay hide js-map-points">
        <a class="map-overlay-close js-btn-overlay-close"><svg class="icon-lines is-inline"><use xlink:href="#icon-cross"/></svg></a>
        <div class="row map-overlay-content">
          <strong class="small-12 columns">{% trans "List of all points on the map:" %}</strong>
          <div class="small-12 columns map-points-list" data-empty-text="{% trans 'No points on the map.' %}"><!-- Points list --></div>
        </div>
      </div>
      <div>
        <div class="map-layers">
          <div>
            {% trans "Map layers:" %}
          </div>
          <div>
            {% include 'parts/map_layers_select.html' with select_name='map-layers-0' selected='googlehybrid'%}
          </div>
          <div>
            <div class="nstSlider map-layers-slider" data-range_min="0" data-range_max="100"
                       data-cur_min="0">
              <div class="leftGrip"></div>
            </div>
          </div>
          <div>
            {% include 'parts/map_layers_select.html' with select_name='map-layers-1' selected='osm'%}
          </div>
        </div>
        <div class="map-form-container"><!-- Map --></div>
      </div>
    </div>

    <div class="single-item">
      <input type="hidden" name="coordinates" value="{{ geometry }}">
    </div>
  </div>
{% endblock %}

{% block footer %}{% endblock %}

{% block bottom %}
  <script>
    $(document).ready(function() {
      $('#map-details-overlay').bindMapActions({inModal: true, editable: false});
    });
  </script>
{% endblock %}

apps/questionnaire/templates/details/review_panel.html
{% load i18n static %}


<div class="row is-rhythmed">
  <div class="review-panel {% if review_css_class %} {{ review_css_class }}{% endif %}" id="review-panel">
    <ol class="process clearfix">
      {% if review_config.has_release %}
      <li class="{% if review_config.review_status == 4 %}is-current{% else %}is-done{% endif %}">{% trans "Edit" %}</li>
      {% else %}
      <li class="{% if review_config.review_status == 0 %}is-current{% else %}is-done{% endif %}">{% trans "Welcome" %}</li>
      {% endif %}
      <li class="{% if review_config.review_status == 1 %}is-current{% else %}is-done{% endif %}">{% trans "Draft" %}</li>
      <li class="{% if review_config.review_status == 2 %}is-current{% else %}is-done{% endif %}">{% trans "Review" %}</li>
      <li class="{% if review_config.review_status == 3 %}is-current{% else %}is-done{% endif %}">{% trans "Publish" %}</li>
    </ol>
    <div class="review-panel-content">
      <form action="{{ review_config.form_action_url }}" method="POST" id="review_form">
        {% if review_config.roles %}
          <div>
            <h3>{% trans "Review status" %}</h3>
              <p><a href="{% url 'wocat:help_questionnaire_introduction' %}" class="link">{% trans "Learn more about the WOCAT documentation of SLM practices." %}</a></p>
          </div>
          <div data-alert class="alert-box success" tabindex="0" aria-live="assertive" role="alertdialog">
            {% for role_code, role_name in review_config.roles %}
            <div class="process-single-role">
              <h3 class="alert-box-title">
                {% blocktrans with role=role_name questionnaire_type=questionnaire_type %}
                You are <strong>{{ role }}</strong> of this {{ questionnaire_type }}.
                {% endblocktrans %}
              </h3>
              {% include 'wocat/help/questionnaire_roles.html' with current_role=role_code questionnaire_type=questionnaire_type %}
            </div>
            {% endfor %}
            {% if review_config.has_new_configuration_edition %}
              <div class="process-single-role">
                <h3 class="alert-box-title">
                  <svg class="icon-lines is-inline"><use xlink:href="#icon-alert"></use></svg>{% trans "New edition of the questionnaire is available." %}
                </h3>
                {% trans "The structure of the questionnaire was updated:" %} <a href="{% url 'configuration:release_notes' %}">{% trans "see all details" %}</a>.
                {% trans "Please start editing the questionnaire in order to update your case data." %}
              </div>
            {% endif %}
          </div>
      {% endif %}

        <div style='display:none'><input type='hidden' name='csrfmiddlewaretoken' value='{{ review_config.csrf_token_value }}'/></div>
        {% if review_config.review_status == 0 %}
          {% if review_config.data_type == 'technologies' or review_config.data_type == 'approaches' %}
            {% include 'details/review_panel/welcome_qtqa.html' %}
          {% elif review_config.data_type == 'watershed' %}
            {% include 'details/review_panel/welcome_watershed.html' %}
          {% endif %}
        {% elif review_config.review_status == 1 %}
          {# Edit #}
          {% include 'details/review_panel/draft.html' with questionnaire_type=questionnaire_type %}
        {% elif review_config.review_status == 2 %}
          {# Review #}
          {% include 'details/review_panel/review.html' with questionnaire_type=questionnaire_type %}
        {% elif review_config.review_status == 3 %}
          {# Publish #}
          {% include 'details/review_panel/publish.html' with questionnaire_type=questionnaire_type %}
        {% elif review_config.review_status == 4 %}
          {# Edit published questionnaire #}
          {% include 'details/review_panel/edit.html' with questionnaire_type=questionnaire_type %}
        {% endif %}
      </form>
    </div>
  </div>
</div>

apps/questionnaire/templates/details/sticky_menu.html
{% load i18n %}

<div class="sticky-content">
  <div class="row">
    <div class="sticky-entry js-sticky-entry-help-toc">
      <div id="sticky-toc" class="sticky-menu sticky-toc-content hide">
        <span class="sticky-toc-title">{% trans "Table of Content" %}</span>
        <ul>
          {% for keyword, label, numbering in toc_content %}
            <li>
              <a href="#{{ keyword }}" class="link">
                {% if numbering %}{{ numbering }} {% endif %}{{ label }}
              </a>
            </li>
          {% endfor %}
        </ul>
      </div>
      <a href="#" class="sticky-entry-link js-sticky-entry-link-toggle" data-toggle="sticky-toc">
        <svg class="icon-lines is-inline"><use xlink:href="#icon-list"></use></svg>{% trans "Table of Content" %}
      </a>
    </div>{% if view_mode == 'edit' %}<div class="sticky-entry">
      <div id="sticky-help" class="sticky-menu sticky-help-content hide">
        <span class="sticky-help-title">{% trans "Help" %}</span>
        <ul>
          <li><a href="#" id="show_help" class="link" onclick="return startIntro();">{% trans "Take a tour explaining the functions on this page." %}</a></li>
        </ul>
      </div>
      <a href="#" class="sticky-entry-link js-sticky-entry-link-toggle" data-toggle="sticky-help">
        <svg class="icon-lines is-inline"><use xlink:href="#icon-information"></use></svg>{% trans "Help" %}
      </a>
    </div>{% endif %}
  </div>
</div>